<template>
  <v-form>
    <v-row class="d-flex justify-space-around">
      <v-menu v-model="menu" nudge-bottom="10" nudge-left="90" offset-y :close-on-content-click="false">
        <template v-slot:activator="{ on }">
          <v-btn v-on="on">Filtry</v-btn>
        </template>
        <v-card class="pa-10">
          <v-text-field v-for="filter in filters" :key="filter.name" v-model="filter.value" :label="filter.label" />

          <v-card-actions class="d-flex justify-space-between">
            <v-btn @click="emitFilters()">Zapisz</v-btn>
            <v-btn @click="menu = false">Anuluj</v-btn>
          </v-card-actions>
        </v-card>
      </v-menu>
    </v-row>

    <v-row class="mb-3">
      <v-col class="d-flex justify-space-around">
        <v-btn-toggle color="indigo">
          <v-btn rounded @click="setDate('2020-05-27')">27.05</v-btn>

          <v-btn rounded @click="setDate('2020-05-28')">28.05</v-btn>

          <v-btn rounded @click="setDate('2020-05-29')">29.05</v-btn>
        </v-btn-toggle>
      </v-col>
    </v-row>
  </v-form>
</template>
<script>
// @group COMPONENTS
export default {
  data() {
    return {
      dirty: '',
      menu: false,
    }
  },
  props: {
    filters: Array,
  },
  methods: {
    /**
     * @vuese
     * Used to emit filters to parent component and closing popup with filters
     * @arg default value is assigned to filters
     */
    emitFilters(filters = this.filters) {
      this.$emit('emitFilters', this.castFilters(filters))
      this.menu = false
    },
    /**
     * @vuese
     * Used to cast filters array to object
     * @arg default value is assigned to filters
     */
    castFilters(filters = this.filters) {
      const castedFilters = {}
      filters.forEach(filter => {
        if (filter.value !== undefined && filter.value !== '') {
          castedFilters[filter.name] = filter.value
        }
      })
      return castedFilters
    },
    /**
     * @vuese
     * Used to set data filter; dirty is used to be able to undo filtering
     * @arg string with date from buttons
     */
    setDate(date) {
      if (this.dirty === date) {
        this.dirty = ''
        this.emitFilters()
      } else {
        this.dirty = date
        this.emitFilters(this.filters.concat({ name: 'date', value: date }))
      }
    },
  },
}
</script>
